﻿using System.Collections.Generic;
using System.Windows;
using System;

namespace Infragistics.Samples
{ 
    public class DataSource : List<DataPoint>
    {        
        public DataSource()  
        {        

            var line1 = CreateLineX(0, 0.1,
                new List<double> {  0, 10, 20, 30, 40, 50, 60, 70, 80, 90 },
                new List<double> { 10, 10, 10, 10, 10, 10, 40, 10, 10, 10 });

            var line2 = CreateLineX(4, 0.1,
                new List<double> {  0, 10, 20, 30, 40, 50, 60, 70, 80, 90 },
                new List<double> { 10, 10, 10, 10, 10, 10, 50, 10, 10, 10 });

            var line3 = CreateLineX(10, 0.1,
                new List<double> {  0, 10, 20, 30, 40, 50, 60, 70, 80, 90 },
                new List<double> { 10, 10, 10, 10, 10, 50, 60, 50, 10, 10 });

            var line4 = CreateLineX(14, 0.1,
                new List<double> {  0, 10, 20, 30, 40, 50, 60, 70, 80, 90 },
                new List<double> { 10, 10, 10, 10, 10, 50, 80, 50, 10, 10 });

            this.AddRange(line1);
            this.AddRange(line2);
            this.AddRange(line3);
            this.AddRange(line4);

               
            //var line1 = CreateLineY(0, 0.1,  // y value
            //    new List<double> { 10, 20, 30, 40, 50, 60, 70, 80, 90 },  // x values
            //    new List<double> { 10, 10, 10, 10, 10, 40, 10, 10, 10 }); // z values
            //var line2 = CreateLineY(10, 0.1, // y value
            //    new List<double> { 10, 20, 30, 40, 50, 60, 70, 80, 90 },  // x values
            //    new List<double> { 10, 10, 10, 10, 50, 60, 50, 10, 10 }); // z values
            
            //var xSinValues = new List<double>();
            //var zSinValues = new List<double>();

            //var xCosValues = new List<double>();
            //var zCosValues = new List<double>();
            //for (int i = 0; i < 360.0; i+=10)
            //{
            //    var x = i;// * 10;
            //    var a = Math.PI * x / 180.0; 
            //    xSinValues.Add(x);
            //    zSinValues.Add(Math.Abs(Math.Sin(a)));

            //    xCosValues.Add(x);
            //    zCosValues.Add(Math.Abs(Math.Cos(a)));
            //}

            //var line1 = CreateLineY(0, 0.1,
            //    xSinValues,
            //    zSinValues);
            //var line2 = CreateLineY(10, 0.1,
            //    xCosValues,
            //    zCosValues);


            //this.Add(new DataPoint(10, 0, 1));
            //this.Add(new DataPoint(20, 0, 1));
            //this.Add(new DataPoint(30, 0, 5));
            //this.Add(new DataPoint(40, 0, 1));
            //this.Add(new DataPoint(50, 0, 1));
            //this.Add(new DataPoint(10, 2, 1));
            //this.Add(new DataPoint(20, 2, 1));
            //this.Add(new DataPoint(30, 2, 5));
            //this.Add(new DataPoint(40, 2, 1));
            //this.Add(new DataPoint(50, 2, 1));

            //this.Add(new DataPoint(10, 4, double.NaN));
            //this.Add(new DataPoint(20, 4, double.NaN));
            //this.Add(new DataPoint(30, 4, double.NaN));
            //this.Add(new DataPoint(40, 4, double.NaN));
            //this.Add(new DataPoint(50, 4, double.NaN));

            //this.Add(new DataPoint(10, 20, 10));
            //this.Add(new DataPoint(20, 20, 20));
            //this.Add(new DataPoint(30, 20, 30));
            //this.Add(new DataPoint(40, 20, 40));
            //this.Add(new DataPoint(50, 20, 50));

            //this.Add(new DataPoint(10, 22, 10));
            //this.Add(new DataPoint(20, 22, 20));
            //this.Add(new DataPoint(30, 22, 30));
            //this.Add(new DataPoint(40, 22, 40));
            //this.Add(new DataPoint(50, 22, 50));

        }
        
        
        public List<DataPoint> CreateLineX(double xValue, double xThickness, List<double> yValues, List<double> zValues)
        {
            if (yValues.Count != zValues.Count)
                throw new Exception("CreateLineX() called with yValues.Count != zValues.Count");

            var points = new List<DataPoint>();
            for (int i = 0; i < yValues.Count; i++)
            { 
                points.Add(new DataPoint(xValue,                       yValues[i], 0));
                //points.Add(new DataPoint(xValue,                       yValues[i], zValues[i]));
                points.Add(new DataPoint(xValue + xThickness,          yValues[i], zValues[i]));
                points.Add(new DataPoint(xValue + xThickness + 0.0001, yValues[i], double.NaN));
            }
            return points;
        }

        public List<DataPoint> CreateLineY(double yValue, double yThickness, List<double> xValues, List<double> zValues)
        {
            if (xValues.Count != zValues.Count)
                throw new Exception("CreateLineY() called with xValues.Count != zValues.Count");

            var points = new List<DataPoint>();
            for (int i = 0; i < xValues.Count; i++)
            { 
                points.Add(new DataPoint(xValues[i], yValue                      , 0));
                //points.Add(new DataPoint(xValues[i], yValue                      , zValues[i]));
                points.Add(new DataPoint(xValues[i], yValue + yThickness         , zValues[i]));
                points.Add(new DataPoint(xValues[i], yValue + yThickness + 0.0001, double.NaN));
            }
            return points;
        }
        
    }

}
